﻿Imports System
Imports System.IO
Imports IWshRuntimeLibrary

Public Class Form1

    Public Shared Sub CriarAtalho(ByVal destination As String)

        ' Cria um instância WshShell através da qual iremos acessar a funcionalidade do
        ' Windows shell.
        Dim hostShell As New WshShell
        ' Monta o nome completamente qualificado que põe o arquivo NotePad.lnk
        ' na pasta de destino. 
        ' Poderiamos usar o  método System.Environment.GetFolderPath
        ' mas o método WshShell.SpecialFolders fornece acesso a maior variedade de pastas
        ' Precisamos criar uma referencia um objeto temporario para a string de destino para
        ' satisfazer os requisitos da assinatura do método
        Dim PastaDestino As Object = DirectCast(destination, Object)
        Dim nomeArquivo As String = Path.Combine(DirectCast(hostShell.SpecialFolders.Item(PastaDestino), String), "Notepad.lnk")
        ' Cria um objeto Atalho. Nada é criado na pasta de destino até que o atalho seja salvo
        Dim atalho As IWshShortcut = DirectCast(hostShell.CriarAtalho(nomeArquivo), IWshShortcut)
        ' Configura o nome qualificado para o executavel
        ' vamos usar a classe Environment por ser mais simples
        atalho.TargetPath = Path.Combine(Environment.GetFolderPath(Environment.SpecialFolder.System), "notepad.exe")
        ' Define o diretorio de trabalho para a pasta Meus Documentos
        atalho.WorkingDirectory = Environment.GetFolderPath(Environment.SpecialFolder.Personal)
        ' Fornece uma descrição para o atalho
        atalho.Description = "Editor Bloco de Notas"
        ' Atribui uma tecla de atalho ao atalho
        atalho.Hotkey = "CTRL+ALT+N"
        ' Configura o para sempre iniciar maximixado
        atalho.WindowStyle = 3
        ' Configura o atalho para exibir o primeiro ícone do Notepad.exe.
        atalho.IconLocation = "notepad.exe,0"
        ' Salva o atalho
        atalho.Save()
    End Sub

    Private Sub btnAtalhoMenuIniciar_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAtalhoMenuIniciar.Click
        ' Cria um atalho para o Bloco de Notas no menu iniciar do Windows para o usuário atual
        CriarAtalho("StartMenu")
    End Sub

    Private Sub btnAtalhoDesktop_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAtalhoDesktop.Click
        ' Cria um atalho para o Bloco de Notas no desktop
        CriarAtalho("Desktop")
    End Sub
End Class
